import sys
import re

class Component(object):
	def __init__(self, id, type, nVals):
		self.id = id
		self.type = type
		# nVals = 0 for infinite values. Depending if it is a product component -->numerable or luk/god -->reals
		self.nVals = nVals
	
	def getId(self):
		return self.id	
		
	def getType(self):
		return self.type
	
	def getNVals(self):
		return self.nVals
	
	
class OrdinalSum(object):

	#components sera una lista de tipo [g4, l, g11, p, l3, g, p], con la interpretacion natural
	def __init__(self, components):
		i = 0
		# components.reverse()
		self.components = []
		for c in components:
			if c == 'l':
				comp = Component(i,'l',0)
				self.components.append(comp)
				i = i+1
			elif c == 'g':
				comp = Component(i,'g',0)
				self.components.append(comp)
				i = i+1
			elif c == 'p':
				comp = Component(i, 'g',2)
				self.components.append(comp)
				i = i+1
				comp = Component(i, 'p',0)
				self.components.append(comp)
				i = i+1
			else:
				lukfin = re.search('(?<=l)([0-9]+)', c)
				godfin = re.search('(?<=g)([0-9]+)', c)
				if lukfin:
					comp = Component(i, 'l',int(lukfin.group(0)))
					self.components.append(comp)
					i = i+1
				else:
					comp = Component(i, 'g',int(godfin.group(0)))
					self.components.append(comp)
					i = i+1
				
	def getComponents(self):
		return self.components
		
	#def getTruth(self):
	#	return self.truth
	
	def getNComponents(self):
		return len(self.components)
		
	def getComponent(self, i):
		return self.components[i]
	
	#def getNProds(self):
	#	return self.prods

				
			
			